Index: pjproject/branches/projects/uwp/pjlib-util/src/pjlib-util/srv_resolver.c
===================================================================
--- pjproject/branches/projects/uwp/pjlib-util/src/pjlib-util/srv_resolver.c	(revision 5512)
+++ pjproject/branches/projects/uwp/pjlib-util/src/pjlib-util/srv_resolver.c	(revision 5513)
@@ -38,20 +38,24 @@
 };
 
+#pragma pack(1)
 struct srv_target
 {
     struct common	    common;
+    struct common	    common_aaaa;
     pj_dns_srv_async_query *parent;
     pj_str_t		    target_name;
     pj_dns_async_query	   *q_a;
+    pj_dns_async_query	   *q_aaaa;
     char		    target_buf[PJ_MAX_HOSTNAME];
     pj_str_t		    cname;
     char		    cname_buf[PJ_MAX_HOSTNAME];
-    unsigned		    port;
+    pj_uint16_t		    port;
     unsigned		    priority;
     unsigned		    weight;
     unsigned		    sum;
     unsigned		    addr_cnt;
-    pj_in_addr		    addr[ADDR_MAX_COUNT];
+    pj_sockaddr		    addr[ADDR_MAX_COUNT];/**< Address family and IP.*/
 };
+#pragma pack()
 
 struct pj_dns_srv_async_query
@@ -136,4 +140,8 @@
     query_job->def_port = (pj_uint16_t)def_port;
 
+    /* Normalize query job option PJ_DNS_SRV_RESOLVE_AAAA_ONLY */
+    if (query_job->option & PJ_DNS_SRV_RESOLVE_AAAA_ONLY)
+	query_job->option |= PJ_DNS_SRV_RESOLVE_AAAA;
+
     /* Start the asynchronous query_job */
 
@@ -178,4 +186,12 @@
 	    srv->q_a = NULL;
 	    has_pending = PJ_TRUE;
+	}
+	if (srv->q_aaaa) {
+	    /* Check if it is a dummy query. */
+	    if (srv->q_aaaa != (pj_dns_async_query*)0x1) {
+		pj_dns_resolver_cancel_query(srv->q_aaaa, PJ_FALSE);
+		has_pending = PJ_TRUE;
+	    }
+	    srv->q_aaaa = NULL;
 	}
     }
@@ -315,6 +331,6 @@
     }
 
-    /* Check for Additional Info section if A records are available, and
-     * fill in the IP address (so that we won't need to resolve the A 
+    /* Check for Additional Info section if A/AAAA records are available, and
+     * fill in the IP address (so that we won't need to resolve the A/AAAA 
      * record with another DNS query_job). 
      */
@@ -323,19 +339,46 @@
 	unsigned j;
 
-	if (rr->type != PJ_DNS_TYPE_A)
+	/* Skip non-A/AAAA record */
+	if (rr->type != PJ_DNS_TYPE_A && rr->type != PJ_DNS_TYPE_AAAA)
 	    continue;
 
-	/* Yippeaiyee!! There is an "A" record! 
+	/* Also skip if:
+	 * - it is A record and app only want AAAA record, or
+	 * - it is AAAA record and app does not want AAAA record
+	 */
+	if ((rr->type == PJ_DNS_TYPE_A &&
+	    (query_job->option & PJ_DNS_SRV_RESOLVE_AAAA_ONLY)!=0) ||
+	    (rr->type == PJ_DNS_TYPE_AAAA &&
+	    (query_job->option & PJ_DNS_SRV_RESOLVE_AAAA)==0))
+	{
+	    continue;
+	}	    
+
+	/* Yippeaiyee!! There is an "A/AAAA" record! 
 	 * Update the IP address of the corresponding SRV record.
 	 */
 	for (j=0; j<query_job->srv_cnt; ++j) {
-            if (pj_stricmp(&rr->name, &query_job->srv[j].target_name)==0 &&
-                query_job->srv[j].addr_cnt < ADDR_MAX_COUNT)
-            {
+	    if (pj_stricmp(&rr->name, &query_job->srv[j].target_name)==0
+		&& query_job->srv[j].addr_cnt < ADDR_MAX_COUNT)
+	    {
 		unsigned cnt = query_job->srv[j].addr_cnt;
-		query_job->srv[j].addr[cnt].s_addr = rr->rdata.a.ip_addr.s_addr;
+		if (rr->type == PJ_DNS_TYPE_A) {
+		    pj_sockaddr_init(pj_AF_INET(),
+					&query_job->srv[j].addr[cnt], NULL,
+					query_job->srv[j].port);
+		    query_job->srv[j].addr[cnt].ipv4.sin_addr =
+						rr->rdata.a.ip_addr;
+		} else {
+		    pj_sockaddr_init(pj_AF_INET6(),
+					&query_job->srv[j].addr[cnt], NULL,
+					query_job->srv[j].port);
+		    query_job->srv[j].addr[cnt].ipv6.sin6_addr =
+						rr->rdata.aaaa.ip_addr;
+		}
+
 		/* Only increment host_resolved once per SRV record */
 		if (query_job->srv[j].addr_cnt == 0)
 		    ++query_job->host_resolved;
+
 		++query_job->srv[j].addr_cnt;
 		break;
@@ -355,4 +398,5 @@
 	}
 	*/
+	
     }
 
@@ -363,4 +407,5 @@
     for (i=0; i<query_job->srv_cnt; ++i) {
 	pj_in_addr addr;
+	pj_in6_addr addr6;
 
 	if (query_job->srv[i].addr_cnt != 0) {
@@ -369,6 +414,23 @@
 	}
 
-	if (pj_inet_aton(&query_job->srv[i].target_name, &addr) != 0) {
-	    query_job->srv[i].addr[query_job->srv[i].addr_cnt++] = addr;
+	if ((query_job->option & PJ_DNS_SRV_RESOLVE_AAAA_ONLY)==0 &&
+	    pj_inet_pton(pj_AF_INET(), &query_job->srv[i].target_name,
+			 &addr) == PJ_SUCCESS)
+	{
+	    unsigned cnt = query_job->srv[i].addr_cnt;
+	    pj_sockaddr_init(pj_AF_INET(), &query_job->srv[i].addr[cnt],
+			     NULL, query_job->srv[i].port);
+	    query_job->srv[i].addr[cnt].ipv4.sin_addr = addr;
+	    ++query_job->srv[i].addr_cnt;
+	    ++query_job->host_resolved;
+	} else if ((query_job->option & PJ_DNS_SRV_RESOLVE_AAAA)!=0 &&
+		   pj_inet_pton(pj_AF_INET6(), &query_job->srv[i].target_name,
+				&addr6) == PJ_SUCCESS)
+	{
+	    unsigned cnt = query_job->srv[i].addr_cnt;
+	    pj_sockaddr_init(pj_AF_INET6(), &query_job->srv[i].addr[cnt],
+			     NULL, query_job->srv[i].port);
+	    query_job->srv[i].addr[cnt].ipv6.sin6_addr = addr6;
+	    ++query_job->srv[i].addr_cnt;
 	    ++query_job->host_resolved;
 	}
@@ -386,10 +448,11 @@
 
     for (i=0; i<query_job->srv_cnt; ++i) {
-	const char *addr;
-
-	if (query_job->srv[i].addr_cnt != 0)
-	    addr = pj_inet_ntoa(query_job->srv[i].addr[0]);
-	else
-	    addr = "-";
+	char addr[PJ_INET6_ADDRSTRLEN];
+
+	if (query_job->srv[i].addr_cnt != 0) {
+	    pj_sockaddr_print(&query_job->srv[i].addr[0],
+			 addr, sizeof(addr), 2);
+	} else
+	    pj_ansi_strcpy(addr, "-");
 
 	PJ_LOG(5,(query_job->objname, 
@@ -405,5 +468,7 @@
 
 
-/* Start DNS A record queries for all SRV records in the query_job structure */
+/* Start DNS A and/or AAAA record queries for all SRV records in
+ * the query_job structure.
+ */
 static pj_status_t resolve_hostnames(pj_dns_srv_async_query *query_job)
 {
@@ -412,4 +477,5 @@
 
     query_job->dns_state = PJ_DNS_TYPE_A;
+
     for (i=0; i<query_job->srv_cnt; ++i) {
 	struct srv_target *srv = &query_job->srv[i];
@@ -421,5 +487,39 @@
 
 	srv->common.type = PJ_DNS_TYPE_A;
+	srv->common_aaaa.type = PJ_DNS_TYPE_AAAA;
 	srv->parent = query_job;
+	srv->q_a = NULL;
+	srv->q_aaaa = NULL;
+
+	status = PJ_SUCCESS;
+
+	/* Start DNA A record query */
+	if ((query_job->option & PJ_DNS_SRV_RESOLVE_AAAA_ONLY) == 0)
+	{
+	    if ((query_job->option & PJ_DNS_SRV_RESOLVE_AAAA) != 0) {
+		/* If there will be DNS AAAA query too, let's setup
+		 * a dummy one here, otherwise app callback may be called
+		 * immediately (before DNS AAAA query is sent) when
+		 * DNS A record is available in the cache.
+		 */
+		srv->q_aaaa = (pj_dns_async_query*)0x1;
+	    }
+	    status = pj_dns_resolver_start_query(query_job->resolver,
+						 &srv->target_name,
+						 PJ_DNS_TYPE_A, 0,
+						 &dns_callback,
+						 &srv->common, &srv->q_a);
+	}
+
+	/* Start DNA AAAA record query */
+	if (status == PJ_SUCCESS &&
+	    (query_job->option & PJ_DNS_SRV_RESOLVE_AAAA) != 0)
+	{
+	    status = pj_dns_resolver_start_query(query_job->resolver,
+						 &srv->target_name,
+						 PJ_DNS_TYPE_AAAA, 0,
+						 &dns_callback,
+						 &srv->common_aaaa, &srv->q_aaaa);
+	}
 
 	/* See also #1809: dns_callback() will be invoked synchronously when response
@@ -428,9 +528,4 @@
 	 * returning false error, so don't use that variable for counting errors.
 	 */
-	status = pj_dns_resolver_start_query(query_job->resolver,
-					     &srv->target_name,
-					     PJ_DNS_TYPE_A, 0,
-					     &dns_callback,
-					     srv, &srv->q_a);
 	if (status != PJ_SUCCESS) {
 	    query_job->host_resolved++;
@@ -462,4 +557,7 @@
 	srv = (struct srv_target*) common;
 	query_job = srv->parent;
+    } else if (common->type == PJ_DNS_TYPE_AAAA) {
+	srv = (struct srv_target*)((pj_int8_t*)common-sizeof(struct common));
+	query_job = srv->parent;
     } else {
 	pj_assert(!"Unexpected user data!");
@@ -472,4 +570,5 @@
 	/* We are getting SRV response */
 
+	/* Clear the outstanding job */
 	query_job->q_srv = NULL;
 
@@ -505,4 +604,6 @@
 	 */
 	if (query_job->srv_cnt == 0) {
+	    unsigned new_option = 0;
+
 	    /* Looks like we aren't getting any SRV responses.
 	     * Resolve the original target as A record by creating a 
@@ -511,5 +612,5 @@
 	    PJ_LOG(4, (query_job->objname, 
 		       "DNS SRV resolution failed for %.*s, trying "
-		       "resolving A record for %.*s",
+		       "resolving A/AAAA record for %.*s",
 		       (int)query_job->full_name.slen, 
 		       query_job->full_name.ptr,
@@ -524,9 +625,18 @@
 	    query_job->srv[i].weight = 0;
 	    query_job->srv[i].port = query_job->def_port;
-	} 
+
+	    /* Update query_job resolution option based on fallback option */
+	    if (query_job->option & PJ_DNS_SRV_FALLBACK_AAAA)
+		new_option |= (PJ_DNS_SRV_RESOLVE_AAAA |
+			       PJ_DNS_SRV_RESOLVE_AAAA_ONLY);
+	    if (query_job->option & PJ_DNS_SRV_FALLBACK_A)
+		new_option &= (~PJ_DNS_SRV_RESOLVE_AAAA_ONLY);
+	    
+	    query_job->option = new_option;
+	}
 	
 
-	/* Resolve server hostnames (DNS A record) for hosts which don't have
-	 * A record yet.
+	/* Resolve server hostnames (DNS A/AAAA record) for hosts which
+	 * don't have A/AAAA record yet.
 	 */
 	if (query_job->host_resolved != query_job->srv_cnt) {
@@ -542,14 +652,28 @@
 
     } else if (query_job->dns_state == PJ_DNS_TYPE_A) {
-
-	/* Clear the outstanding job */
-	srv->q_a = NULL;
+	pj_bool_t is_type_a, srv_completed;
+
+	/* Clear outstanding job */
+	if (common->type == PJ_DNS_TYPE_A) {
+	    srv_completed = (srv->q_aaaa == NULL);
+	    srv->q_a = NULL;
+	} else if (common->type == PJ_DNS_TYPE_AAAA) {
+	    srv_completed = (srv->q_a == NULL);
+	    srv->q_aaaa = NULL;
+	} else {
+	    pj_assert(!"Unexpected job type");
+	    query_job->last_error = status = PJ_EINVALIDOP;
+	    goto on_error;
+	}
+
+	is_type_a = (common->type == PJ_DNS_TYPE_A);
 
 	/* Check that we really have answer */
 	if (status==PJ_SUCCESS && pkt->hdr.anscount != 0) {
-	    pj_dns_a_record rec;
+	    char addr[PJ_INET6_ADDRSTRLEN];
+	    pj_dns_addr_record rec;
 
 	    /* Parse response */
-	    status = pj_dns_parse_a_response(pkt, &rec);
+	    status = pj_dns_parse_addr_response(pkt, &rec);
 	    if (status != PJ_SUCCESS)
 		goto on_error;
@@ -558,33 +682,51 @@
 
 	    /* Update CNAME alias, if present. */
-	    if (rec.alias.slen) {
+	    if (srv->cname.slen==0 && rec.alias.slen) {
 		pj_assert(rec.alias.slen <= (int)sizeof(srv->cname_buf));
 		srv->cname.ptr = srv->cname_buf;
 		pj_strcpy(&srv->cname, &rec.alias);
-	    } else {
-		srv->cname.slen = 0;
+	    //} else {
+		//srv->cname.slen = 0;
 	    }
 
 	    /* Update IP address of the corresponding hostname or CNAME */
-	    if (srv->addr_cnt < ADDR_MAX_COUNT) {
-		srv->addr[srv->addr_cnt++].s_addr = rec.addr[0].s_addr;
-
-		PJ_LOG(5,(query_job->objname, 
-			  "DNS A for %.*s: %s",
-			  (int)srv->target_name.slen, 
-			  srv->target_name.ptr,
-			  pj_inet_ntoa(rec.addr[0])));
-	    }
-
-	    /* Check for multiple IP addresses */
-	    for (i=1; i<rec.addr_count && srv->addr_cnt < ADDR_MAX_COUNT; ++i)
+	    for (i=0; i<rec.addr_count && srv->addr_cnt<ADDR_MAX_COUNT; ++i)
 	    {
-		srv->addr[srv->addr_cnt++].s_addr = rec.addr[i].s_addr;
-
-		PJ_LOG(5,(query_job->objname, 
-			  "Additional DNS A for %.*s: %s",
-			  (int)srv->target_name.slen, 
-			  srv->target_name.ptr,
-			  pj_inet_ntoa(rec.addr[i])));
+		pj_bool_t added = PJ_FALSE;
+
+		if (is_type_a && rec.addr[i].af == pj_AF_INET()) {
+		    pj_sockaddr_init(pj_AF_INET(), &srv->addr[srv->addr_cnt],
+				     NULL, srv->port);
+		    srv->addr[srv->addr_cnt].ipv4.sin_addr =
+				     rec.addr[i].ip.v4;
+		    added = PJ_TRUE;
+		} else if (!is_type_a && rec.addr[i].af == pj_AF_INET6()) {
+		    pj_sockaddr_init(pj_AF_INET6(), &srv->addr[srv->addr_cnt],
+				     NULL, srv->port);
+		    srv->addr[srv->addr_cnt].ipv6.sin6_addr =
+				     rec.addr[i].ip.v6;
+		    added = PJ_TRUE;
+		} else {
+		    /* Mismatched address family, e.g: getting IPv6 address in
+		     * DNS A query resolution.
+		     */
+		    PJ_LOG(4,(query_job->objname, 
+			      "Bad address family in DNS %s query for %.*s",
+			      (is_type_a? "A" : "AAAA"),
+			      (int)srv->target_name.slen, 
+			      srv->target_name.ptr));
+		}
+
+		if (added) {
+		    PJ_LOG(5,(query_job->objname, 
+			      "DNS %s for %.*s: %s",
+			      (is_type_a? "A" : "AAAA"),
+			      (int)srv->target_name.slen, 
+			      srv->target_name.ptr,
+			      pj_sockaddr_print(&srv->addr[srv->addr_cnt],
+						addr, sizeof(addr), 2)));
+
+		    ++srv->addr_cnt;
+		}
 	    }
 
@@ -597,9 +739,15 @@
 	    /* Log error */
 	    pj_strerror(status, errmsg, sizeof(errmsg));
-	    PJ_LOG(4,(query_job->objname, "DNS A record resolution failed: %s", 
+	    PJ_LOG(4,(query_job->objname,
+		      "DNS %s record resolution failed: %s",
+		      (is_type_a? "A" : "AAAA"),
 		      errmsg));
 	}
 
-	++query_job->host_resolved;
+	/* Increment host resolved count when both DNS A and AAAA record
+	 * queries for this server are completed.
+	 */
+	if (srv_completed)
+	    ++query_job->host_resolved;
 
     } else {
@@ -618,4 +766,5 @@
 	    unsigned j;
 	    struct srv_target *srv2 = &query_job->srv[i];
+	    pj_dns_addr_record *s = &srv_rec.entry[srv_rec.count].server;
 
 	    srv_rec.entry[srv_rec.count].priority = srv2->priority;
@@ -629,8 +778,11 @@
 	    pj_assert(srv2->addr_cnt <= PJ_DNS_MAX_IP_IN_A_REC);
 
-	    for (j=0; j<srv2->addr_cnt; ++j) {
-		srv_rec.entry[srv_rec.count].server.addr[j].s_addr = 
-		    srv2->addr[j].s_addr;
-		++srv_rec.entry[srv_rec.count].server.addr_count;
+	    for (j=0; j<srv2->addr_cnt; ++j) {		
+		s->addr[j].af = srv2->addr[j].addr.sa_family;
+		if (s->addr[j].af == pj_AF_INET())
+		    s->addr[j].ip.v4 = srv2->addr[j].ipv4.sin_addr;
+		else
+		    s->addr[j].ip.v6 = srv2->addr[j].ipv6.sin6_addr;
+		++s->addr_count;
 	    }
 
@@ -675,4 +827,8 @@
 		  status,
 		  pj_strerror(status,errmsg,sizeof(errmsg)).ptr));
+
+	/* Cancel any pending query */
+	pj_dns_srv_cancel_query(query_job, PJ_FALSE);
+
 	(*query_job->cb)(query_job->token, status, NULL);
 	return;
Index: pjproject/branches/projects/uwp/pjlib-util/src/pjlib-util/stun_simple_client.c
===================================================================
--- pjproject/branches/projects/uwp/pjlib-util/src/pjlib-util/stun_simple_client.c	(revision 5512)
+++ pjproject/branches/projects/uwp/pjlib-util/src/pjlib-util/stun_simple_client.c	(revision 5513)
@@ -34,5 +34,4 @@
 
 #define THIS_FILE	"stun_client.c"
-#define LOG_ADDR(addr)	pj_inet_ntoa(addr.sin_addr), pj_ntohs(addr.sin_port)
 
 #define TRACE_(x)	PJ_LOG(6,x)
Index: pjproject/branches/projects/uwp/pjlib/build/Makefile
===================================================================
--- pjproject/branches/projects/uwp/pjlib/build/Makefile	(revision 5512)
+++ pjproject/branches/projects/uwp/pjlib/build/Makefile	(revision 5513)
@@ -35,5 +35,5 @@
 	guid.o hash.o ip_helper_generic.o list.o lock.o log.o os_time_common.o \
 	os_info.o pool.o pool_buf.o pool_caching.o pool_dbg.o rand.o \
-	rbtree.o sock_common.o sock_qos_common.o sock_qos_bsd.o \
+	rbtree.o sock_common.o sock_qos_common.o \
 	ssl_sock_common.o ssl_sock_ossl.o ssl_sock_dump.o \
 	string.o timer.o types.o
Index: pjproject/branches/projects/uwp/pjlib/build/os-auto.mak.in
===================================================================
--- pjproject/branches/projects/uwp/pjlib/build/os-auto.mak.in	(revision 5512)
+++ pjproject/branches/projects/uwp/pjlib/build/os-auto.mak.in	(revision 5513)
@@ -34,3 +34,9 @@
 export TARGETS_EXE  =   $(TEST_EXE)
 
+ifeq (@ac_ssl_has_ec@,1)
+export PJLIB_CFLAGS += -DPJ_SSL_SOCK_OSSL_HAS_EC=1
+endif
 
+ifeq (@ac_ssl_has_sigalg@,1)
+export PJLIB_CFLAGS += -DPJ_SSL_SOCK_OSSL_HAS_SIGALG=1
+endif
Index: pjproject/branches/projects/uwp/pjlib/build/os-darwinos.mak
===================================================================
--- pjproject/branches/projects/uwp/pjlib/build/os-darwinos.mak	(revision 5512)
+++ pjproject/branches/projects/uwp/pjlib/build/os-darwinos.mak	(revision 5513)
@@ -19,4 +19,6 @@
 export PJLIB_OBJS += file_access_unistd.o file_io_ansi.o
 
+export PJLIB_OBJS += sock_qos_darwin.o
+
 #
 # TEST_OBJS are operating system specific object files to be included in
Index: pjproject/branches/projects/uwp/pjlib/build/os-linux-kernel.mak
===================================================================
--- pjproject/branches/projects/uwp/pjlib/build/os-linux-kernel.mak	(revision 5512)
+++ pjproject/branches/projects/uwp/pjlib/build/os-linux-kernel.mak	(revision 5513)
@@ -21,4 +21,6 @@
 export PJLIB_OBJS +=	ioqueue_epoll.o 
 #export PJLIB_OBJS +=	ioqueue_select.o 
+
+export PJLIB_OBJS +=	sock_qos_bsd.o
 
 #
Index: pjproject/branches/projects/uwp/pjlib/build/os-linux.mak
===================================================================
--- pjproject/branches/projects/uwp/pjlib/build/os-linux.mak	(revision 5512)
+++ pjproject/branches/projects/uwp/pjlib/build/os-linux.mak	(revision 5513)
@@ -21,4 +21,6 @@
 endif
 
+export PJLIB_OBJS += sock_qos_bsd.o
+
 #
 # TEST_OBJS are operating system specific object files to be included in
Index: pjproject/branches/projects/uwp/pjlib/build/os-rtems.mak
===================================================================
--- pjproject/branches/projects/uwp/pjlib/build/os-rtems.mak	(revision 5512)
+++ pjproject/branches/projects/uwp/pjlib/build/os-rtems.mak	(revision 5513)
@@ -19,4 +19,5 @@
 export PJLIB_OBJS += ioqueue_select.o 
 export PJLIB_OBJS += file_access_unistd.o file_io_ansi.o
+export PJLIB_OBJS += sock_qos_bsd.o
 
 #
Index: pjproject/branches/projects/uwp/pjlib/build/os-sunos.mak
===================================================================
--- pjproject/branches/projects/uwp/pjlib/build/os-sunos.mak	(revision 5512)
+++ pjproject/branches/projects/uwp/pjlib/build/os-sunos.mak	(revision 5513)
@@ -18,4 +18,6 @@
 #export PJLIB_OBJS += ioqueue_epoll.o
 
+export PJLIB_OBJS += sock_qos_bsd.o
+
 #
 # TEST_OBJS are operating system specific object files to be included in
Index: pjproject/branches/projects/uwp/pjlib/build/os-win32.mak
===================================================================
--- pjproject/branches/projects/uwp/pjlib/build/os-win32.mak	(revision 5512)
+++ pjproject/branches/projects/uwp/pjlib/build/os-win32.mak	(revision 5513)
@@ -20,4 +20,6 @@
 #export PJLIB_OBJS +=	file_io_ansi.o
 
+export PJLIB_OBJS +=	sock_qos_bsd.o
+
 #
 # TEST_OBJS are operating system specific object files to be included in
Index: pjproject/branches/projects/uwp/pjlib/include/pj/compat/os_auto.h.in
===================================================================
--- pjproject/branches/projects/uwp/pjlib/include/pj/compat/os_auto.h.in	(revision 5512)
+++ pjproject/branches/projects/uwp/pjlib/include/pj/compat/os_auto.h.in	(revision 5513)
@@ -84,4 +84,5 @@
 #undef PJ_HAS_WS2TCPIP_H
 
+#undef PJ_SOCK_HAS_IPV6_V6ONLY
 #undef PJ_SOCK_HAS_INET_ATON
 #undef PJ_SOCK_HAS_INET_PTON
@@ -129,4 +130,7 @@
 #undef PJ_SELECT_NEEDS_NFDS
 
+/* Was Linux epoll support enabled */
+#undef PJ_HAS_LINUX_EPOLL
+
 /* Is errno a good way to retrieve OS errors?
  */
@@ -163,4 +167,7 @@
 #endif
 
+/* Is localtime_r() available? */
+#undef PJ_HAS_LOCALTIME_R
+
 /* Unicode? */
 #undef PJ_NATIVE_STRING_IS_UNICODE
@@ -173,4 +180,11 @@
 
 #if defined(PJ_DARWINOS) && PJ_DARWINOS!=0
+     /* Disable local host resolution in pj_gethostip() (see ticket #1342) */
+#    define PJ_GETHOSTIP_DISABLE_LOCAL_RESOLUTION 1
+     /* Use pj_getaddrinfo() (instead of pj_inet_pton()) in
+      * pj_sockaddr_set_str_addr()
+      */
+#    define PJ_SOCKADDR_USE_GETADDRINFO 1
+
 #    include "TargetConditionals.h"
 #    if TARGET_OS_IPHONE
@@ -178,6 +192,4 @@
 	/* Use CFHost API for pj_getaddrinfo() (see ticket #1246) */
 #	define PJ_GETADDRINFO_USE_CFHOST 1
-	/* Disable local host resolution in pj_gethostip() (see ticket #1342) */
-#	define PJ_GETHOSTIP_DISABLE_LOCAL_RESOLUTION 1
 #    	ifdef __IPHONE_4_0
  	    /* Is multitasking support available?  (see ticket #1107) */
Index: pjproject/branches/projects/uwp/pjlib/include/pj/compat/os_darwinos.h
===================================================================
--- pjproject/branches/projects/uwp/pjlib/include/pj/compat/os_darwinos.h	(revision 5512)
+++ pjproject/branches/projects/uwp/pjlib/include/pj/compat/os_darwinos.h	(revision 5513)
@@ -55,4 +55,6 @@
 #define PJ_HAS_WINSOCK_H	    0
 #define PJ_HAS_WINSOCK2_H	    0
+
+#define PJ_HAS_LOCALTIME_R	    1
 
 /* Is errno a good way to retrieve OS errors?
Index: pjproject/branches/projects/uwp/pjlib/include/pj/compat/os_linux.h
===================================================================
--- pjproject/branches/projects/uwp/pjlib/include/pj/compat/os_linux.h	(revision 5512)
+++ pjproject/branches/projects/uwp/pjlib/include/pj/compat/os_linux.h	(revision 5513)
@@ -55,4 +55,6 @@
 #define PJ_HAS_WINSOCK_H	    0
 #define PJ_HAS_WINSOCK2_H	    0
+
+#define PJ_HAS_LOCALTIME_R	    1
 
 #define PJ_SOCK_HAS_INET_ATON	    1
Index: pjproject/branches/projects/uwp/pjlib/include/pj/compat/socket.h
===================================================================
--- pjproject/branches/projects/uwp/pjlib/include/pj/compat/socket.h	(revision 5512)
+++ pjproject/branches/projects/uwp/pjlib/include/pj/compat/socket.h	(revision 5513)
@@ -65,5 +65,5 @@
 #   endif
 
-#   if !defined(IPPROTO_IPV6)
+#   if !defined(IPPROTO_IPV6) && (_WIN32_WINNT == 0x0500)
 	/* Need to download and install IPv6Kit for this platform.
 	 * Please see the comments above about Visual Studio 6.
@@ -159,4 +159,6 @@
 #  define OSERR_ECONNRESET     WSAECONNRESET
 #  define OSERR_ENOTCONN       WSAENOTCONN
+#  define OSERR_EAFNOSUPPORT   WSAEAFNOSUPPORT
+#  define OSERR_ENOPROTOOPT    WSAENOPROTOOPT
 #elif defined(PJ_SYMBIAN) && PJ_SYMBIAN!=0
 #  define OSERR_EWOULDBLOCK    -1
@@ -164,4 +166,6 @@
 #  define OSERR_ECONNRESET     -1
 #  define OSERR_ENOTCONN       -1
+#  define OSERR_EAFNOSUPPORT   -1
+#  define OSERR_ENOPROTOOPT    -1
 #else
 #  define OSERR_EWOULDBLOCK    EWOULDBLOCK
@@ -169,4 +173,6 @@
 #  define OSERR_ECONNRESET     ECONNRESET
 #  define OSERR_ENOTCONN       ENOTCONN
+#  define OSERR_EAFNOSUPPORT   EAFNOSUPPORT
+#  define OSERR_ENOPROTOOPT    ENOPROTOOPT
 #endif
 
Index: pjproject/branches/projects/uwp/pjlib/include/pj/config.h
===================================================================
--- pjproject/branches/projects/uwp/pjlib/include/pj/config.h	(revision 5512)
+++ pjproject/branches/projects/uwp/pjlib/include/pj/config.h	(revision 5513)
@@ -873,4 +873,7 @@
 #define PJ_QOS_SYMBIAN	    4
 
+/** QoS backend for Darwin */
+#define PJ_QOS_DARWIN	    5
+
 /**
  * Force the use of some QoS backend API for some platforms.
@@ -915,4 +918,14 @@
 #ifndef PJ_SSL_SOCK_OSSL_CIPHERS
 #  define PJ_SSL_SOCK_OSSL_CIPHERS   "HIGH:-COMPLEMENTOFDEFAULT"
+#endif
+
+
+/**
+ * Define the maximum number of curves supported by the secure socket.
+ *
+ * Default: 32
+ */
+#ifndef PJ_SSL_SOCK_MAX_CURVES
+#  define PJ_SSL_SOCK_MAX_CURVES   32
 #endif
 
@@ -1248,5 +1261,5 @@
 
 /** PJLIB version minor number. */
-#define PJ_VERSION_NUM_MINOR	4
+#define PJ_VERSION_NUM_MINOR	5
 
 /** PJLIB version revision number. */
Index: pjproject/branches/projects/uwp/pjlib/include/pj/config_site_sample.h
===================================================================
--- pjproject/branches/projects/uwp/pjlib/include/pj/config_site_sample.h	(revision 5512)
+++ pjproject/branches/projects/uwp/pjlib/include/pj/config_site_sample.h	(revision 5513)
@@ -437,4 +437,6 @@
     #undef PJMEDIA_AUDIO_DEV_HAS_PORTAUDIO
     #define PJMEDIA_AUDIO_DEV_HAS_PORTAUDIO		0
+    #undef PJMEDIA_AUDIO_DEV_HAS_ALSA
+    #define PJMEDIA_AUDIO_DEV_HAS_ALSA			0    
 #endif
 
@@ -476,5 +478,4 @@
 #   define PJSIP_SAFE_MODULE		0
 #   define PJ_HAS_STRICMP_ALNUM		0
-#   define PJ_HASH_USE_OWN_TOLOWER	1
 #   define PJSIP_UNESCAPE_IN_PLACE	1
 
Index: pjproject/branches/projects/uwp/pjlib/include/pj/log.h
===================================================================
--- pjproject/branches/projects/uwp/pjlib/include/pj/log.h	(revision 5512)
+++ pjproject/branches/projects/uwp/pjlib/include/pj/log.h	(revision 5513)
@@ -106,6 +106,7 @@
  */
 #define PJ_LOG(level,arg)	do { \
-				    if (level <= pj_log_get_level()) \
+				    if (level <= pj_log_get_level()) { \
 					pj_log_wrapper_##level(arg); \
+				    } \
 				} while (0)
 
Index: pjproject/branches/projects/uwp/pjlib/include/pj/sock.h
===================================================================
--- pjproject/branches/projects/uwp/pjlib/include/pj/sock.h	(revision 5512)
+++ pjproject/branches/projects/uwp/pjlib/include/pj/sock.h	(revision 5513)
@@ -277,4 +277,17 @@
 
 
+/** IPV6_TCLASS optname in setsockopt(). @see pj_IPV6_TCLASS() */
+extern const pj_uint16_t PJ_IPV6_TCLASS;
+
+
+#if defined(PJ_DLL)
+    /** Get #PJ_IPV6_TCLASS constant */
+    PJ_DECL(int) pj_IPV6_TCLASS(void);
+#else
+    /** Get #PJ_IPV6_TCLASS constant */
+#   define pj_IPV6_TCLASS()	PJ_IPV6_TCLASS
+#endif
+
+
 /**
  * Values to be specified as \c optname when calling #pj_sock_setsockopt() 
Index: pjproject/branches/projects/uwp/pjlib/include/pj/sock_qos.h
===================================================================
--- pjproject/branches/projects/uwp/pjlib/include/pj/sock_qos.h	(revision 5512)
+++ pjproject/branches/projects/uwp/pjlib/include/pj/sock_qos.h	(revision 5513)
@@ -122,8 +122,9 @@
      {
 	PJ_QOS_TYPE_BEST_EFFORT,
-	PJ_QOS_TYPE_BACKGROUND,
+	PJ_QOS_TYPE_BACKGROUND,	
 	PJ_QOS_TYPE_VIDEO,
 	PJ_QOS_TYPE_VOICE,
-	PJ_QOS_TYPE_CONTROL
+	PJ_QOS_TYPE_CONTROL,
+	PJ_QOS_TYPE_SIGNALLING
      } pj_qos_type;
     \endcode
@@ -142,4 +143,5 @@
     VOICE 		0x30 		VO (Voice) 		6
     CONTROL 		0x38 		VO (Voice) 		7
+    SIGNALLING 		0x28 		VI (Video) 		5
     =================================================================
     \endcode
@@ -236,8 +238,9 @@
 				     Any QoS function calls with specifying
 				     this value are effectively no-op	*/
-    PJ_QOS_TYPE_BACKGROUND,	/**< Background traffic.		*/
+    PJ_QOS_TYPE_BACKGROUND,	/**< Background traffic.		*/    
     PJ_QOS_TYPE_VIDEO,		/**< Video traffic.			*/
     PJ_QOS_TYPE_VOICE,		/**< Voice traffic.			*/
-    PJ_QOS_TYPE_CONTROL		/**< Control traffic.			*/
+    PJ_QOS_TYPE_CONTROL,	/**< Control traffic.			*/
+    PJ_QOS_TYPE_SIGNALLING	/**< Signalling traffic.		*/
 } pj_qos_type;
 
